// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S174_ReferencesOtherAuthority.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S174_ReferencesOtherAuthority extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int referenceDirettore = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\1\2\0\2\1"+
    "\1\0\1\5\12\6\1\7\1\10\5\0\1\11\1\12"+
    "\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22"+
    "\1\23\1\24\1\25\1\26\1\27\1\30\1\22\1\31"+
    "\1\32\1\33\1\34\1\35\1\36\1\22\1\37\1\22"+
    "\1\40\1\0\1\41\1\0\1\42\1\0\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\0"+
    "\1\54\1\55\1\56\1\57\1\60\1\61\1\0\1\62"+
    "\1\63\1\64\1\65\1\66\1\67\1\0\1\70\266\0"+
    "\2\53\115\0\1\63\u0182\0\1\1\20\0\2\1\u0115\0"+
    "\1\54\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\41\0\1\5"+
    "\114\0\1\6\10\0\1\5\7\0\1\7\213\0\1\10";

  private static int [] zzUnpackAction() {
    int [] result = new int[288];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\71\0\162\0\253\0\344\0\253\0\u011d\0\253"+
    "\0\u0156\0\u018f\0\u01c8\0\u0201\0\u023a\0\u0273\0\u02ac\0\u02e5"+
    "\0\u031e\0\u0357\0\u0390\0\253\0\u03c9\0\u0402\0\u043b\0\u0474"+
    "\0\u04ad\0\u04e6\0\u051f\0\u0558\0\u0591\0\u05ca\0\u0603\0\u063c"+
    "\0\u0675\0\u06ae\0\u06e7\0\u0720\0\u0759\0\u0792\0\u07cb\0\u0804"+
    "\0\u083d\0\u0876\0\u08af\0\u08e8\0\u0921\0\u095a\0\u0993\0\u09cc"+
    "\0\u0a05\0\u0a3e\0\u0a77\0\u0ab0\0\u0ae9\0\253\0\u0b22\0\u0b5b"+
    "\0\u0b94\0\u0bcd\0\u0c06\0\u0c3f\0\u0c78\0\u0cb1\0\u0cea\0\u0d23"+
    "\0\u0d5c\0\u0d95\0\u0dce\0\u0e07\0\u0e40\0\u0e79\0\u0eb2\0\u0eeb"+
    "\0\u0f24\0\u0f5d\0\u0f96\0\u0fcf\0\u1008\0\u1041\0\u107a\0\u10b3"+
    "\0\u10ec\0\u1125\0\u115e\0\u1197\0\u11d0\0\u1209\0\u1242\0\u127b"+
    "\0\u12b4\0\u12ed\0\u1326\0\u135f\0\u1398\0\u13d1\0\u140a\0\u1443"+
    "\0\u147c\0\u14b5\0\u14ee\0\u1527\0\u1560\0\u1599\0\u15d2\0\u160b"+
    "\0\u1644\0\u167d\0\u16b6\0\u16ef\0\u1728\0\u1761\0\u179a\0\u17d3"+
    "\0\u180c\0\u1845\0\u187e\0\u18b7\0\u18f0\0\u1929\0\u1962\0\u199b"+
    "\0\u19d4\0\u1a0d\0\u1a46\0\u1a7f\0\u1ab8\0\u1af1\0\u1b2a\0\u1b63"+
    "\0\u1b9c\0\u1bd5\0\253\0\u1c0e\0\u1c47\0\u1c80\0\u1cb9\0\u1cf2"+
    "\0\u1d2b\0\u1d64\0\u1d9d\0\u1dd6\0\u1e0f\0\u1dd6\0\u1e48\0\u1e81"+
    "\0\u1eba\0\u1ef3\0\u1f2c\0\253\0\u1f65\0\u1f9e\0\u1fd7\0\u2010"+
    "\0\u2049\0\u2082\0\u20bb\0\u20f4\0\u212d\0\u2166\0\u219f\0\u21d8"+
    "\0\u2211\0\u224a\0\u2283\0\u22bc\0\u22f5\0\u232e\0\u2367\0\u23a0"+
    "\0\u23d9\0\u2412\0\u244b\0\u2484\0\u24bd\0\u24f6\0\u252f\0\u2568"+
    "\0\u25a1\0\u25da\0\u2613\0\u264c\0\u2685\0\u26be\0\u26f7\0\u2730"+
    "\0\u2769\0\u27a2\0\u27db\0\u2814\0\u284d\0\u2886\0\u28bf\0\u28f8"+
    "\0\u2931\0\u296a\0\u29a3\0\u29dc\0\u2a15\0\u2a4e\0\u2a87\0\u2ac0"+
    "\0\u2af9\0\u2b32\0\u2b6b\0\u2ba4\0\u2bdd\0\u2c16\0\u2c4f\0\u2c88"+
    "\0\u2cc1\0\u2cfa\0\u2d33\0\u2d6c\0\u2da5\0\u2dde\0\u2e17\0\u2e50"+
    "\0\u2e89\0\u2ec2\0\u2efb\0\u2f34\0\u2f6d\0\u2fa6\0\u2fdf\0\u3018"+
    "\0\u3051\0\u308a\0\u30c3\0\u30fc\0\u3135\0\u316e\0\u31a7\0\u31e0"+
    "\0\u3219\0\u3252\0\u328b\0\u32c4\0\u32fd\0\u3336\0\u336f\0\u33a8"+
    "\0\u33e1\0\u341a\0\u3453\0\u348c\0\u34c5\0\u34fe\0\u3537\0\u3570"+
    "\0\u35a9\0\u35e2\0\u361b\0\u3654\0\u368d\0\u36c6\0\u36ff\0\u3738"+
    "\0\u3771\0\u37aa\0\u37e3\0\u381c\0\u3855\0\u388e\0\u38c7\0\u3900"+
    "\0\u3939\0\u3972\0\u39ab\0\u39e4\0\u3a1d\0\u3a56\0\u3a8f\0\u3ac8"+
    "\0\u3b01\0\u3b3a\0\u3b73\0\u3bac\0\u3be5\0\u3c1e\0\u3c57\0\u3c90"+
    "\0\u3cc9\0\u3d02\0\u3d3b\0\u3d74\0\u3dad\0\u3de6\0\u3e1f\0\u32fd";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[288];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\40\4\1\5\30\4\40\6\1\7\30\6\40\10\1\11"+
    "\30\10\115\0\1\12\30\0\1\12\20\0\1\13\107\0"+
    "\1\14\30\0\1\14\36\0\1\15\30\0\1\15\40\0"+
    "\1\16\30\0\1\16\36\0\1\17\30\0\1\17\42\0"+
    "\1\20\30\0\1\20\34\0\1\21\30\0\1\21\42\0"+
    "\1\22\30\0\1\22\20\0\1\23\107\0\1\24\30\0"+
    "\1\24\20\0\1\25\72\0\3\26\1\27\7\26\1\30"+
    "\13\26\2\0\1\26\3\0\1\31\6\0\1\32\24\0"+
    "\21\33\1\34\5\33\2\0\1\33\20\0\1\35\14\0"+
    "\1\36\1\0\27\26\2\0\1\26\35\0\1\36\1\0"+
    "\16\26\1\37\10\26\2\0\1\26\15\0\1\40\17\0"+
    "\1\36\1\0\4\26\1\41\22\26\2\0\1\26\4\0"+
    "\1\42\50\0\1\40\30\0\1\40\25\0\1\42\31\0"+
    "\1\42\30\0\1\43\1\0\27\33\2\0\1\33\35\0"+
    "\1\43\1\0\22\33\1\44\4\33\2\0\1\33\21\0"+
    "\1\45\37\0\1\45\30\0\1\45\4\0\2\36\2\0"+
    "\3\36\1\46\30\36\2\0\27\36\7\0\1\36\1\0"+
    "\2\26\1\47\24\26\2\0\1\26\2\0\1\50\36\0"+
    "\1\50\31\0\1\50\32\0\1\36\1\0\6\26\1\51"+
    "\20\26\2\0\1\26\6\0\1\52\36\0\1\52\31\0"+
    "\1\52\17\0\2\43\2\0\3\43\1\53\30\43\2\0"+
    "\27\43\7\0\1\43\1\0\17\33\1\54\7\33\2\0"+
    "\1\33\16\0\1\55\37\0\1\55\30\0\1\55\15\0"+
    "\1\56\71\0\1\36\1\0\22\26\1\57\4\26\2\0"+
    "\1\26\21\0\1\60\37\0\1\60\30\0\1\60\13\0"+
    "\1\36\1\0\27\26\2\0\1\61\70\0\1\62\34\0"+
    "\1\63\71\0\1\43\1\0\25\33\1\64\1\33\2\0"+
    "\1\33\24\0\1\65\37\0\1\65\30\0\1\65\7\0"+
    "\1\56\32\0\1\66\36\0\1\36\1\0\26\26\1\67"+
    "\2\0\1\26\25\0\1\70\37\0\1\70\30\0\1\70"+
    "\7\0\1\36\1\0\3\26\1\27\23\26\2\0\1\26"+
    "\3\0\1\31\36\0\1\31\31\0\1\31\30\0\1\63"+
    "\32\0\1\71\36\0\1\72\1\0\27\33\2\0\1\33"+
    "\35\0\1\72\70\0\1\36\1\0\17\26\1\73\7\26"+
    "\2\0\1\26\16\0\1\74\37\0\1\74\30\0\1\74"+
    "\7\0\40\75\1\0\30\75\2\72\2\0\3\72\1\76"+
    "\30\72\2\0\27\72\7\0\1\36\1\0\4\26\1\77"+
    "\22\26\2\0\1\26\4\0\1\100\36\0\1\100\31\0"+
    "\1\100\21\0\40\75\1\101\30\75\6\0\1\102\71\0"+
    "\1\103\1\0\27\26\2\0\1\26\35\0\1\104\66\0"+
    "\1\105\71\0\1\102\32\0\1\106\27\0\2\36\2\0"+
    "\3\36\1\46\3\36\1\107\1\110\4\36\1\111\4\36"+
    "\1\112\1\113\1\114\1\115\6\36\2\0\3\36\1\107"+
    "\1\110\4\36\1\111\3\36\1\112\1\113\1\114\1\115"+
    "\6\36\13\0\1\116\1\117\4\0\1\120\4\0\1\121"+
    "\1\122\1\123\1\124\13\0\1\116\1\117\4\0\1\120"+
    "\3\0\1\121\1\122\1\123\1\124\32\0\1\125\30\0"+
    "\1\125\13\0\40\126\1\0\30\126\2\36\2\0\3\36"+
    "\1\46\11\36\1\127\16\36\2\0\11\36\1\127\17\36"+
    "\2\0\3\36\1\46\5\36\1\130\22\36\2\0\5\36"+
    "\1\130\23\36\2\0\3\36\1\46\16\36\1\131\11\36"+
    "\2\0\15\36\1\131\13\36\2\0\3\36\1\46\17\36"+
    "\1\132\10\36\2\0\16\36\1\132\12\36\2\0\3\36"+
    "\1\46\21\36\1\133\6\36\2\0\20\36\1\133\10\36"+
    "\2\0\3\36\1\46\1\36\1\134\17\36\1\135\6\36"+
    "\2\0\1\36\1\134\16\36\1\135\10\36\2\0\3\36"+
    "\1\46\5\36\1\136\3\36\1\137\16\36\2\0\5\36"+
    "\1\136\3\36\1\137\15\36\21\0\1\140\31\0\1\140"+
    "\32\0\1\141\31\0\1\141\47\0\1\142\30\0\1\142"+
    "\40\0\1\143\30\0\1\143\41\0\1\144\30\0\1\144"+
    "\17\0\1\145\17\0\1\146\11\0\1\145\16\0\1\146"+
    "\23\0\1\147\3\0\1\150\25\0\1\147\3\0\1\150"+
    "\40\0\1\151\30\0\1\151\14\0\40\126\1\152\30\126"+
    "\2\36\2\0\3\36\1\46\21\36\1\153\6\36\2\0"+
    "\20\36\1\153\10\36\2\0\3\36\1\46\3\36\1\154"+
    "\10\36\1\155\6\36\1\155\4\36\2\0\3\36\1\154"+
    "\7\36\1\155\6\36\1\155\6\36\2\0\3\36\1\46"+
    "\23\36\1\156\4\36\2\0\22\36\1\156\6\36\2\0"+
    "\3\36\1\46\23\36\1\157\4\36\2\0\22\36\1\157"+
    "\6\36\2\0\3\36\1\46\4\36\1\155\23\36\2\0"+
    "\4\36\1\155\24\36\2\0\3\36\1\46\21\36\1\160"+
    "\6\36\2\0\20\36\1\160\10\36\2\0\3\36\1\46"+
    "\17\36\1\161\10\36\2\0\16\36\1\161\12\36\2\0"+
    "\3\36\1\46\7\36\1\155\20\36\2\0\7\36\1\155"+
    "\21\36\2\0\3\36\1\46\22\36\1\155\5\36\2\0"+
    "\21\36\1\155\5\36\31\0\1\162\30\0\1\162\21\0"+
    "\1\163\10\0\1\164\6\0\1\164\11\0\1\163\7\0"+
    "\1\164\6\0\1\164\37\0\1\165\30\0\1\165\37\0"+
    "\1\166\30\0\1\166\20\0\1\164\31\0\1\164\53\0"+
    "\1\167\30\0\1\167\35\0\1\170\30\0\1\170\27\0"+
    "\1\164\31\0\1\164\51\0\1\164\30\0\1\164\33\0"+
    "\1\171\30\0\1\171\16\0\1\172\63\0\2\36\2\0"+
    "\3\36\1\46\3\36\1\155\24\36\2\0\3\36\1\155"+
    "\25\36\2\0\3\36\1\46\21\36\1\155\6\36\2\0"+
    "\20\36\1\155\10\36\2\0\3\36\1\173\30\36\2\0"+
    "\31\36\2\0\3\36\1\46\5\36\1\174\22\36\2\0"+
    "\5\36\1\174\23\36\2\0\3\36\1\46\1\36\1\155"+
    "\26\36\2\0\1\36\1\155\27\36\2\0\3\36\1\46"+
    "\5\36\1\175\22\36\2\0\5\36\1\175\23\36\2\0"+
    "\3\36\1\46\25\36\1\176\2\36\2\0\24\36\1\176"+
    "\2\36\13\0\1\164\31\0\1\164\54\0\1\164\30\0"+
    "\1\164\15\0\1\177\76\0\1\200\31\0\1\200\32\0"+
    "\1\164\31\0\1\164\42\0\1\201\31\0\1\201\56\0"+
    "\1\202\30\0\1\202\43\0\1\203\53\0\1\204\30\0"+
    "\1\204\21\0\1\205\62\0\2\36\2\0\3\36\1\46"+
    "\21\36\1\206\6\36\2\0\20\36\1\206\10\36\2\0"+
    "\3\36\1\46\21\36\1\207\6\36\2\0\20\36\1\207"+
    "\10\36\2\0\3\36\1\46\25\36\1\155\2\36\2\0"+
    "\24\36\1\155\2\36\6\0\1\210\113\0\1\211\30\0"+
    "\1\211\37\0\1\212\30\0\1\212\43\0\1\164\30\0"+
    "\1\164\25\0\1\213\30\0\1\213\22\0\1\205\32\0"+
    "\1\214\27\0\2\36\2\0\3\36\1\46\20\36\1\215"+
    "\7\36\2\0\17\36\1\215\11\36\2\0\3\36\1\46"+
    "\5\36\1\155\22\36\2\0\5\36\1\155\21\36\6\0"+
    "\1\210\32\0\1\216\57\0\1\217\30\0\1\217\24\0"+
    "\1\164\31\0\1\164\47\0\1\220\30\0\1\220\11\0"+
    "\40\221\1\0\30\221\2\36\2\0\3\36\1\46\5\36"+
    "\1\222\22\36\2\0\5\36\1\222\21\36\15\0\1\223"+
    "\31\0\1\223\62\0\1\224\27\0\40\221\1\225\30\221"+
    "\2\36\2\0\3\36\1\46\14\36\1\226\13\36\2\0"+
    "\13\36\1\226\13\36\24\0\1\227\30\0\1\227\20\0"+
    "\1\230\63\0\2\36\2\0\3\36\1\46\14\36\1\231"+
    "\13\36\2\0\13\36\1\231\13\36\24\0\1\232\30\0"+
    "\1\232\37\0\1\233\30\0\1\233\13\0\2\36\2\0"+
    "\3\36\1\46\17\36\1\155\10\36\2\0\16\36\1\155"+
    "\10\36\27\0\1\164\30\0\1\164\33\0\1\234\30\0"+
    "\1\234\42\0\1\235\30\0\1\235\52\0\1\236\30\0"+
    "\2\236\1\0\1\237\33\0\1\240\1\0\1\236\54\0"+
    "\1\241\30\0\1\241\35\0\1\242\30\0\1\242\25\0"+
    "\1\243\31\0\1\243\47\0\1\244\30\0\1\244\46\0"+
    "\1\245\30\0\1\245\33\0\1\246\30\0\1\246\41\0"+
    "\1\247\30\0\1\247\16\0\1\250\71\0\1\236\71\0"+
    "\1\251\12\0\1\252\5\0\1\253\10\0\1\251\11\0"+
    "\1\252\5\0\1\253\41\0\1\254\30\0\1\254\20\0"+
    "\1\255\31\0\1\255\54\0\1\256\30\0\1\256\37\0"+
    "\1\257\30\0\1\257\23\0\1\260\31\0\1\260\47\0"+
    "\1\261\30\0\1\261\27\0\1\262\31\0\1\262\60\0"+
    "\1\263\64\0\1\264\30\0\1\264\10\0\1\265\72\0"+
    "\1\251\31\0\1\251\34\0\1\266\75\0\1\267\31\0"+
    "\1\267\22\0\2\266\2\0\3\266\1\177\30\266\2\0"+
    "\27\266\21\0\1\270\31\0\1\270\46\0\1\271\30\0"+
    "\1\271\23\0\1\272\31\0\1\272\54\0\1\273\30\0"+
    "\1\273\37\0\1\274\30\0\1\274\33\0\1\275\30\0"+
    "\1\275\41\0\1\276\30\0\1\276\23\0\1\277\31\0"+
    "\1\277\30\0\1\300\67\0\1\301\70\0\1\301\32\0"+
    "\1\302\27\0\40\303\1\0\70\303\1\304\30\303\5\0"+
    "\1\305\107\0\1\306\30\0\1\306\36\0\1\307\30\0"+
    "\1\307\42\0\1\310\30\0\1\310\52\0\1\311\30\0"+
    "\2\311\1\0\1\312\33\0\1\313\1\0\1\311\54\0"+
    "\1\314\30\0\1\314\35\0\1\315\30\0\1\315\25\0"+
    "\1\316\31\0\1\316\47\0\1\317\30\0\1\317\46\0"+
    "\1\320\30\0\1\320\33\0\1\321\30\0\1\321\41\0"+
    "\1\322\30\0\1\322\16\0\1\323\71\0\1\311\107\0"+
    "\1\324\2\0\1\325\25\0\1\324\2\0\1\325\40\0"+
    "\1\326\30\0\1\326\37\0\1\327\30\0\1\327\24\0"+
    "\1\330\31\0\1\330\46\0\1\331\30\0\1\331\24\0"+
    "\1\332\31\0\1\332\57\0\1\333\30\0\1\333\32\0"+
    "\1\334\30\0\1\334\15\0\1\335\123\0\1\336\26\0"+
    "\2\335\2\0\3\335\1\300\30\335\2\0\27\335\11\0"+
    "\1\337\31\0\1\337\61\0\1\340\30\0\1\340\36\0"+
    "\1\341\30\0\1\341\24\0\1\342\31\0\1\342\25\0"+
    "\1\343\61\0\2\343\2\0\3\343\1\344\30\343\2\0"+
    "\27\343\6\0\1\345\70\0\1\345\32\0\1\346\27\0"+
    "\40\347\1\0\70\347\1\350\30\347\5\0\1\351\107\0"+
    "\1\352\30\0\1\352\36\0\1\353\30\0\1\353\42\0"+
    "\1\354\30\0\1\354\52\0\1\355\30\0\2\355\1\0"+
    "\1\356\33\0\1\357\1\0\1\355\54\0\1\360\30\0"+
    "\1\360\35\0\1\361\30\0\1\361\25\0\1\362\31\0"+
    "\1\362\47\0\1\363\30\0\1\363\46\0\1\364\30\0"+
    "\1\364\33\0\1\365\30\0\1\365\41\0\1\366\30\0"+
    "\1\366\16\0\1\367\71\0\1\355\74\0\1\370\1\0"+
    "\1\371\7\0\1\372\3\0\1\373\4\0\1\374\6\0"+
    "\1\370\1\0\1\371\6\0\1\372\3\0\1\373\4\0"+
    "\1\374\27\0\1\375\30\0\1\375\44\0\1\376\30\0"+
    "\1\376\37\0\1\377\30\0\1\377\36\0\1\u0100\30\0"+
    "\1\u0100\21\0\1\u0101\31\0\1\u0101\34\0\1\u0102\31\0"+
    "\1\u0102\47\0\1\u0103\30\0\1\u0103\40\0\1\u0104\30\0"+
    "\1\u0104\42\0\1\u0105\30\0\1\u0105\20\0\1\u0106\31\0"+
    "\1\u0106\67\0\1\u0107\52\0\1\u0108\30\0\1\u0108\25\0"+
    "\1\u0109\31\0\1\u0109\62\0\1\342\30\0\1\342\32\0"+
    "\1\u010a\30\0\1\u010a\22\0\1\u010b\31\0\1\u010b\64\0"+
    "\1\u010c\43\0\1\u010d\31\0\1\u010d\30\0\1\u010e\72\0"+
    "\1\u010f\31\0\1\u010f\53\0\1\u0110\30\0\1\u0110\42\0"+
    "\1\u0111\30\0\1\u0111\6\0\2\u010e\2\0\3\u010e\1\u0112"+
    "\30\u010e\2\0\27\u010e\33\0\1\u0113\30\0\1\u0113\40\0"+
    "\1\u0114\30\0\1\u0114\12\0\1\u010e\32\0\1\u0115\34\0"+
    "\1\u0116\77\0\1\u010a\31\0\1\u010a\46\0\1\u0117\30\0"+
    "\1\u0117\51\0\1\374\30\0\1\374\6\0\1\u0116\32\0"+
    "\1\u0118\41\0\1\u0119\31\0\1\u0119\24\0\40\u011a\1\0"+
    "\30\u011a\15\0\1\u0106\31\0\1\u0106\21\0\40\u011a\1\u011b"+
    "\30\u011a\5\0\1\u011c\107\0\1\u011d\30\0\1\u011d\36\0"+
    "\1\u011e\30\0\1\u011e\42\0\1\u011f\30\0\1\u011f\52\0"+
    "\1\u0120\27\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[15960];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\41\0\1\11\114\0\1\11\10\0\1\1\7\0"+
    "\1\11\213\0\1\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[288];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S174_ReferencesOtherAuthority() { }
	




  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S174_ReferencesOtherAuthority(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 9: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 10: break;
          case 3:
            { checkEnd();
            }
          // fall through
          case 11: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 12: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 13: break;
          case 6:
            { offset += yylength();
		
		AnnotationEntity retrievedEntity = retrieveEntity();
		
		annotationEntity.addRelatedEntity(retrievedEntity);
            }
          // fall through
          case 14: break;
          case 7:
            { offset += yylength();
            }
          // fall through
          case 15: break;
          case 8:
            { //System.out.println("DIRETTORE FULL: " + yytext());
	
	Reference ref = new Reference(Entity.LEG_REF);
	
	ref.setContext(Util.removeAllAnnotations(yytext())); 
		
	start(ref, referenceDirettore, false, false);
            }
          // fall through
          case 16: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S174_ReferencesOtherAuthority [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S174_ReferencesOtherAuthority scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S174_ReferencesOtherAuthority(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
